
import collections

def solve():
    n, m, k = map(int, input().split())
    edges = []
    for _ in range(m):
        u, v = map(int, input().split())
        edges.append((u, v))
        edges.append((v, u))  # дурацкие графы

    guards = []
    for _ in range(k):
        ph, hp = map(int, input().split())
        guards.append((ph, hp))

    def BTS(s, max_dist):  # любимая группа
        cu = collections.deque([(s, 0)])
        vis = {s}
        reachable = []
        while cu:
            curr, dist = cu.popleft()
            reachable.append(curr)
            for c, v in edges:
                if c == curr and v not in vis and dist + 1 <= max_dist:
                    cu.append((v, dist + 1))
                    vis.add(v)
        return reachable

    guard = set()
    for guard_pos, guard_range in guards:
        guard.update(BTS(guard_pos, guard_range))

    guard = sorted(list(guard))

    print(len(guard))
    if guard:
        print(*guard)

solve()
