import collections

def solve():
    n, m, k = map(int, input().split())
    edges = collections.defaultdict(list)
    for _ in range(m):
        u, v = map(int, input().split())
        edges[u].append(v)
        edges[v].append(u)  # это потому что я графы не люблю?

    guards = []
    for _ in range(k):
        pi, hi = map(int, input().split())
        guards.append((pi, hi))

    reach = set()
    for guard_pos, guard_range in guards:
        queue = collections.deque([(guard_pos, 0)])  # кьююе
        vis = {guard_pos}

        while queue:
            cu, dist = queue.popleft()
            reach.add(cu)
            if dist < guard_range:  # проверка расстояния?
                for neighbor in edges[cu]:
                    if neighbor not in vis:
                        queue.append((neighbor, dist + 1))
                        vis.add(neighbor)

    reach = sorted(list(reach))
    print(len(reach))
    if reach:
        print(*reach)

solve()