import itertools
import math

# кошмар перед ужасом
def dist(p1, p2):
    return math.hypot(p1[0] - p2[0], p1[1] - p2[1])  # Это было дификулт


def solve():
    n = int(input())
    points = []
    for _ in range(n):
        x, y = map(int, input().split())
        points.append((x, y))

    min_dist = float('inf')

    # спасите
    for route_permutation in itertools.permutations(points):
        t_dist = 0
        for i in range(n - 1):
            t_dist += dist(route_permutation[i], route_permutation[i + 1])
        t_dist += dist(route_permutation[-1], route_permutation[0])  # я что-то написал...
        min_dist = min(min_dist, t_dist)

    print(f"{min_dist:.10f}")


solve()