import collections


def solve():
    n, m, k = map(int, input().split())
    e = collections.defaultdict(list)
    for _ in range(m):
        u, v = map(int, input().split())
        e[u].append(v)
        e[v].append(u)  # fu

    guards = []
    for _ in range(k):
        pi, hi = map(int, input().split())
        guards.append((pi, hi))

    reach = set()
    queue = collections.deque([(guard_pos, 0) for guard_pos, _ in guards])  # сегодня будет кьююе.
    vis = set(guard_pos for guard_pos, _ in guards)

    while queue:
        cu, dist = queue.popleft()
        reach.add(cu)
        for guard_pos, guard_range in guards:
            if dist <= guard_range:
                for neighbor in e[cu]:
                    if neighbor not in vis and dist + 1 <= guard_range:
                        queue.append((neighbor, dist + 1))
                        vis.add(neighbor)

    reach = sorted(list(reach))
    print(len(reach))
    if reach:
        print(*reach)


solve()
