import collections

def solve():
    n, m, k = map(int, input().split())
    graph = collections.defaultdict(list)
    for _ in range(m):
        u, v = map(int, input().split())
        graph[u].append((v,1))  # это вес (пока что 1, почти мой)
        graph[v].append((u,1))  # теперь я люблю графы...

    guards = []
    for _ in range(k):
        guard_pos, guard_range = map(int, input().split())
        guards.append((guard_pos, guard_range))

    reach = set()
    for guard_pos, guard_range in guards:
        queue = collections.deque([(guard_pos, 0)])  # кьююе
        vis = {guard_pos}

        while queue:
            node, dist = queue.popleft()
            reach.add(node)
            if dist < guard_range:
                for neighbor, w in graph[node]: # норм вес
                    if neighbor not in vis:
                        queue.append((neighbor, dist + w))
                        vis.add(neighbor)

    reach = sorted(list(reach))
    print(len(reach))
    if reach:
        print(*reach)

solve()